//---------------------------------------------------------------------------
#pragma hdrstop
//-------------------------------------------------------------------------
#include <math.h>
#include "BPonto3D.h"
#include "BVetor3D.h"
//---------------------------------------------------------------------------
BPonto3D::BPonto3D(void)
{
    x = 0;
    y = 0;
    z = 0;
}
//---------------------------------------------------------------------------
BPonto3D::BPonto3D(double xx, double yy, double zz)
{
    x = xx;
    y = yy;
    z = zz;
}
//---------------------------------------------------------------------------
BPonto3D::BPonto3D(const BPonto3D& p)
{
    x = p.x;
    y = p.y;
    z = p.z;
}
//---------------------------------------------------------------------------
BPonto3D::~BPonto3D(void)
{

}
//---------------------------------------------------------------------------
BPonto3D& BPonto3D::operator = (const BPonto3D& p)
{
    x = p.x;
    y = p.y;
    z = p.z;
    return *this;
}
//---------------------------------------------------------------------------
bool operator == (const BPonto3D& p1, const BPonto3D& p2)
{
    return ((p1.x == p2.x) && (p1.y == p2.y) && (p1.z == p2.z));
}
//---------------------------------------------------------------------------
BPonto3D operator + (const BPonto3D& p1, const BPonto3D& p2)
{
    return BPonto3D(p1.x + p2.x, p1.y + p2.y, p1.z + p2.z);
}
//---------------------------------------------------------------------------
BVetor3D operator - (const BPonto3D& p1, const BPonto3D& p2)
{
    return BVetor3D(p1.X() - p2.X(), p1.Y() - p2.Y(), p1.Z() - p2.Z());
}
//---------------------------------------------------------------------------
void BPonto3D::DefCoordenadas(double xx, double yy, double zz)
{
    x = xx;
    y = yy;
    z = zz;
}
//---------------------------------------------------------------------------
BPonto3D PontoMedio(const BPonto3D& p1, const BPonto3D& p2)
{
    return BPonto3D(0.5 * (p1.x + p2.x), 0.5 * (p1.y + p2.y), 0.5 * (p1.z + p2.z));
}
//---------------------------------------------------------------------------
bool PontosEmLinha(const BPonto3D& p1, const BPonto3D& p2, const BPonto3D& p3)
{
    double xtmp, ytmp, ztmp;

    if(p2.x == p1.x)
    {
        return (p3.x == p1.x);
    }
    if(p2.y == p1.y)
    {
        return (p3.y == p1.y);
    }
    if(p2.z == p1.z)
    {
        return (p3.z == p1.z);
    }
    xtmp = (p3.x - p1.x) / (p2.x - p1.x);
    ytmp = (p3.y - p1.y) / (p2.y - p1.y);
    ztmp = (p3.z - p1.z) / (p2.z - p1.z);
    return ((xtmp == ytmp) && (xtmp == ztmp));
}
//---------------------------------------------------------------------------

