//---------------------------------------------------------------------------
#pragma hdrstop
//-------------------------------------------------------------------------
#include <math.h>
#include "BVetor3D.h"
//---------------------------------------------------------------------------
BVetor3D::BVetor3D(void)
{
    x = 0;
    y = 0;
    z = 0;
}
//---------------------------------------------------------------------------
BVetor3D::BVetor3D(double xx, double yy, double zz)
{
    x = xx;
    y = yy;
    z = zz;
}
//---------------------------------------------------------------------------
BVetor3D::BVetor3D(const BVetor3D& v)
{
    x = v.x;
    x = v.y;
    x = v.z;
}
//---------------------------------------------------------------------------
BVetor3D::~BVetor3D(void)
{

}
//---------------------------------------------------------------------------
BVetor3D& BVetor3D::operator = (const BVetor3D& v)
{
    x = v.x;
    y = v.y;
    z = v.z;
    return *this;
}
//---------------------------------------------------------------------------
BVetor3D operator + (const BVetor3D& v1, const BVetor3D& v2)
{
    return BVetor3D(v1.x + v2.x, v1.y + v2.y, v1.z + v2.z);
}
//---------------------------------------------------------------------------
BVetor3D operator + (double d, const BVetor3D& v)
{
    return BVetor3D(v.x + d, v.y + d, v.z + d);
}
//---------------------------------------------------------------------------
BVetor3D operator + (const BVetor3D& v, double d)
{
    return BVetor3D(v.x + d, v.y + d, v.z + d);
}
//---------------------------------------------------------------------------
BPonto3D operator + (const BPonto3D& p, const BVetor3D& v)
{
    return BPonto3D(v.x + p.X(), v.y + p.Y(), v.z + p.Z());
}
//---------------------------------------------------------------------------
BVetor3D operator - (const BVetor3D& v1, const BVetor3D& v2)
{
    return BVetor3D(v1.x - v2.x, v1.y - v2.y, v1.z - v2.z);
}
//---------------------------------------------------------------------------
BVetor3D operator - (const BVetor3D& v, double d)
{
    return BVetor3D(v.x - d, v.y - d, v.z - d);
}
//---------------------------------------------------------------------------
double operator * (const BVetor3D& v1, const BVetor3D& v2)
{
    return v1.x * v2.x + v1.y * v2.y + v1.z * v2.z;
}
//---------------------------------------------------------------------------
BVetor3D operator * (double d, const BVetor3D& v)
{
    return BVetor3D(v.x * d, v.y * d, v.z * d);
}
//---------------------------------------------------------------------------
BVetor3D operator * (const BVetor3D& v, double d)
{
    return BVetor3D(v.X() * d, v.Y() * d, v.Z() * d);
}
//---------------------------------------------------------------------------
BVetor3D operator / (const BVetor3D& v, double d)
{
    if(d == 0)
    {
        throw;
    }
    return BVetor3D(v.X() / d, v.Y() / d, v.Z() / d);
}
//---------------------------------------------------------------------------
void BVetor3D::DefCoordenadas(double xx, double yy, double zz)
{
    x = xx;
    y = yy;
    z = zz;
}
//---------------------------------------------------------------------------
double Modulo(const BVetor3D& v)
{
    return sqrt(v.X() * v.X() + v.Y() * v.Y() + v.Z() * v.Z());
}
//---------------------------------------------------------------------------
BVetor3D ProdutoVetorial(const BVetor3D& v1, const BVetor3D& v2)
{
    BVetor3D vetor;

    vetor.X() = v1.Y() * v2.Z() - v1.Z() * v2.Y();
    vetor.Y() = v1.Z() * v2.X() - v1.X() * v2.Z();
    vetor.Z() = v1.X() * v2.Y() - v1.Y() * v2.X();
    return vetor;
}
//---------------------------------------------------------------------------
BVetor3D Unitario(const BVetor3D& v)
{
    double mod = Modulo(v);

    if(mod == 0)
    {
        throw;
    }
    return BVetor3D(v.X() / mod, v.Y() / mod, v.Z() / mod);
}
//---------------------------------------------------------------------------

