//---------------------------------------------------------------------------
#ifndef BVetor3DH
#define BVetor3DH
//---------------------------------------------------------------------------
#include "BPonto3D.h"
//---------------------------------------------------------------------------
class BVetor3D
{
private:
   double x;
   double y;
   double z;

protected:

public:
   BVetor3D(void);
   BVetor3D(double xx, double yy, double zz);
   BVetor3D(const BVetor3D& v);
   virtual ~BVetor3D(void);
   //operadores
   BVetor3D& operator = (const BVetor3D& v);
   friend BVetor3D operator + (const BVetor3D& v1, const BVetor3D& v2);
   friend BVetor3D operator + (double d, const BVetor3D& v);
   friend BVetor3D operator + (const BVetor3D& v, double d);
   friend BPonto3D operator + (const BPonto3D& p, const BVetor3D& v);
   friend BVetor3D operator - (const BVetor3D& v1, const BVetor3D& v2);
   friend BVetor3D operator - (const BVetor3D& v, double d);
   friend double   operator * (const BVetor3D& v1, const BVetor3D& v2);
   friend BVetor3D operator * (double d, const BVetor3D& p);
   friend BVetor3D operator * (const BVetor3D& v, double d);
   friend BVetor3D operator / (const BVetor3D& v, double d);
   //funcoes membro
   void DefCoordenadas(double xx, double yy, double zz);
   inline double& X(void);
   inline const double& X(void) const;
   inline double& Y(void);
   inline const double& Y(void) const;
   inline double& Z(void);
   inline const double& Z(void) const;
   //funcoes nao-membro
   friend double Modulo(const BVetor3D& v);
   friend BVetor3D ProdutoVetorial(const BVetor3D& v1, const BVetor3D& v2);
   friend BVetor3D Unitario(const BVetor3D& v);
};
//---------------------------------------------------------------------------
double& BVetor3D::X(void)
{
    return x;
}
//---------------------------------------------------------------------------
const double& BVetor3D::X(void) const
{
    return x;
}
//---------------------------------------------------------------------------
double& BVetor3D::Y(void)
{
    return y;
}
//---------------------------------------------------------------------------
const double& BVetor3D::Y(void) const
{
    return y;
}
//---------------------------------------------------------------------------
double& BVetor3D::Z(void)
{
    return z;
}
//---------------------------------------------------------------------------
const double& BVetor3D::Z(void) const
{
    return z;
}
//---------------------------------------------------------------------------
#endif
